"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var StatusReporter_1 = require('./StatusReporter');
var actions_1 = require('./actions');
var Record = (function (_super) {
    __extends(Record, _super);
    function Record(synchronized) {
        _super.call(this, synchronized);
        this._original = this;
    }
    Object.defineProperty(Record.prototype, "original", {
        get: function () {
            return this._original;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Record.prototype, "error", {
        get: function () {
            return this.validate();
        },
        enumerable: true,
        configurable: true
    });
    Record.prototype.clear = function (dispatch) {
        dispatch(actions_1.CLAY_DATA_CLEAR.create.unicast(this.id));
    };
    Record.prototype.setRemoved = function () {
        if (this._status.removed) {
            return this;
        }
        var clone = this._original.clone();
        clone._status = this._status.setRemoved();
        return clone;
    };
    Record.prototype.checkValidity = function () {
        return !this.validate() && this.validateFields();
    };
    Record.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._original = this._original;
    };
    return Record;
}(StatusReporter_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Record;
