"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var StatusReporter_1 = require('./StatusReporter');
var actions_1 = require('./actions');
var isEqual = require('lodash.isequal');
var Value = (function (_super) {
    __extends(Value, _super);
    function Value(validator, synchronized, value) {
        if (synchronized === void 0) { synchronized = false; }
        _super.call(this, synchronized);
        this._original = synchronized ? this : null;
        this._validator = validator;
        this._value = value;
    }
    Object.defineProperty(Value.prototype, "value", {
        get: function () {
            return this._value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Value.prototype, "original", {
        get: function () {
            return this._original;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Value.prototype, "error", {
        get: function () {
            if (!this._validator) {
                return null;
            }
            return this._validator(this._value);
        },
        enumerable: true,
        configurable: true
    });
    Value.prototype.reduce = function (action) {
        if (actions_1.CLAY_DATA_CLEAR.is(this.id, action)) {
            if (!this._original) {
                return this;
            }
            return this._original;
        }
        if (actions_1.CLAY_DATA_DECAY.is(this.id, action)) {
            if (!this._status.fresh) {
                return this;
            }
            var clone = this.clone();
            clone._status = this._status.setDecayed();
            return clone;
        }
        if (actions_1.CLAY_DATA_SET_VALUE.is(this.id, action)) {
            if (isEqual(this._value, action.payload)) {
                return this;
            }
            if (this._original && isEqual(this._original.value, action.payload)) {
                return this._original;
            }
            var clone = this.clone();
            clone._value = action.payload;
            if (this._status.fresh) {
                clone._status = this._status.setDecayed();
            }
            else if (this._status.synchronized && !this._status.modified) {
                clone._status = this._status.setModified();
            }
            return clone;
        }
        return this;
    };
    Value.prototype.clear = function (dispatch) {
        dispatch(actions_1.CLAY_DATA_CLEAR.create.unicast(this.id));
    };
    Value.prototype.decay = function (dispatch) {
        dispatch(actions_1.CLAY_DATA_DECAY.create.unicast(this.id));
    };
    Value.prototype.set = function (dispatch, value) {
        dispatch(actions_1.CLAY_DATA_SET_VALUE.create.unicast(this.id, value));
    };
    Value.prototype.checkValidity = function () {
        if (!this._validator) {
            return true;
        }
        return !this._validator(this._value);
    };
    Value.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._original = this._original;
        clone._validator = this._validator;
        clone._value = this._value;
    };
    Value.prototype.createInstance = function () {
        return new Value();
    };
    return Value;
}(StatusReporter_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Value;
