"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require('../UniqueReducible');
var actions_1 = require('./actions');
var Attributor = (function (_super) {
    __extends(Attributor, _super);
    function Attributor(attributes) {
        _super.call(this);
        if (Array.isArray(attributes)) {
            this._attributes = attributes.slice();
        }
    }
    Object.defineProperty(Attributor.prototype, "attributes", {
        get: function () {
            return this._attributes || [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Attributor.prototype, "plain", {
        get: function () {
            if (!Array.isArray(this._attributes) || this._attributes.length === 0) {
                return null;
            }
            return this._attributes.slice();
        },
        enumerable: true,
        configurable: true
    });
    Attributor.prototype.reduce = function (action) {
        if (actions_1.CLAY_QUERY_SET_ATTRIBUTES.is(this.id, action)) {
            var clone = this.clone();
            clone._attributes = action.payload;
            return clone;
        }
        return this;
    };
    Attributor.prototype.set = function (dispatch, attributes) {
        if (Array.isArray(attributes)) {
            dispatch(actions_1.CLAY_QUERY_SET_ATTRIBUTES.create.unicast(this.id, attributes.slice()));
        }
        else {
            dispatch(actions_1.CLAY_QUERY_SET_ATTRIBUTES.create.unicast(this.id));
        }
    };
    Attributor.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._attributes = this._attributes;
    };
    Attributor.prototype.createInstance = function () {
        return new Attributor();
    };
    return Attributor;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Attributor;
