"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var immutable_1 = require('immutable');
var UniqueReducible_1 = require('../UniqueReducible');
var SubQuerier_1 = require('./SubQuerier');
var Includer = (function (_super) {
    __extends(Includer, _super);
    function Includer(include) {
        _super.call(this);
        if (Array.isArray(include)) {
            this._subQueriers = immutable_1.List(include.filter(function (s) { return !!s; }).map(function (subQuery) { return new SubQuerier_1.default(subQuery); }));
        }
        else {
            this._subQueriers = immutable_1.List();
        }
    }
    Object.defineProperty(Includer.prototype, "subQueriers", {
        get: function () {
            return this._subQueriers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Includer.prototype, "plain", {
        get: function () {
            if (this._subQueriers.size === 0) {
                return null;
            }
            var include = [];
            this._subQueriers.forEach(function (subQuerier) {
                include.push(subQuerier.plain);
            });
            return include;
        },
        enumerable: true,
        configurable: true
    });
    Includer.prototype.reduce = function (action) {
        var _this = this;
        var modified = false;
        var newSubQueriers = this._subQueriers.withMutations(function (s) {
            _this._subQueriers.forEach(function (subQuerier, index) {
                var newSubQuerier = subQuerier.reduce(action);
                if (newSubQuerier !== subQuerier) {
                    modified = true;
                    s.set(index, newSubQuerier);
                }
            });
        });
        if (modified) {
            var clone = this.clone();
            clone._subQueriers = newSubQueriers;
            return clone;
        }
        return this;
    };
    Includer.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._subQueriers = this._subQueriers;
    };
    Includer.prototype.createInstance = function () {
        return new Includer();
    };
    return Includer;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Includer;
