"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require('../UniqueReducible');
var Includer_1 = require('./Includer');
var Filterer_1 = require('./Filterer');
var Attributor_1 = require('./Attributor');
var Paginator_1 = require('./Paginator');
var Orderer_1 = require('./Orderer');
var Querier = (function (_super) {
    __extends(Querier, _super);
    function Querier(query) {
        _super.call(this);
        if (query === null) {
            return;
        }
        this._model = query.model;
        this._byId = query.byId;
        this._count = !!query.count;
        this._includer = new Includer_1.default(query.include);
        this._filterer = new Filterer_1.default(query.filters);
        this._attributor = new Attributor_1.default(query.attributes);
        this._paginator = new Paginator_1.default(query.pagination);
        this._orderer = new Orderer_1.default(query.order);
    }
    Object.defineProperty(Querier.prototype, "model", {
        get: function () {
            return this._model;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Querier.prototype, "byId", {
        get: function () {
            return this._byId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Querier.prototype, "count", {
        get: function () {
            return this._count;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Querier.prototype, "includer", {
        get: function () {
            return this._includer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Querier.prototype, "filterer", {
        get: function () {
            return this._filterer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Querier.prototype, "attributor", {
        get: function () {
            return this._attributor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Querier.prototype, "paginator", {
        get: function () {
            return this._paginator;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Querier.prototype, "orderer", {
        get: function () {
            return this._orderer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Querier.prototype, "plain", {
        get: function () {
            var query = {};
            query.model = this._model;
            if (typeof this._byId === 'number') {
                query.byId = this._byId;
            }
            var include = this._includer.plain;
            if (include !== null) {
                query.include = include;
            }
            var filters = this._filterer.plain;
            if (filters !== null) {
                query.filters = filters;
            }
            var attributes = this._attributor.plain;
            if (attributes !== null) {
                query.attributes = attributes;
            }
            if (this._count === true) {
                query.count = true;
            }
            var pagination = this._paginator.plain;
            if (pagination !== null) {
                query.pagination = pagination;
            }
            var order = this._orderer.plain;
            if (order !== null) {
                query.order = order;
            }
            return query;
        },
        enumerable: true,
        configurable: true
    });
    Querier.prototype.reduce = function (action) {
        var includer = this._includer.reduce(action);
        var filterer = this._filterer.reduce(action);
        var attributor = this._attributor.reduce(action);
        var paginator = this._paginator.reduce(action);
        var orderer = this._orderer.reduce(action);
        if (includer !== this._includer ||
            filterer !== this._filterer ||
            attributor !== this._attributor ||
            paginator !== this._paginator ||
            orderer !== this._orderer) {
            var clone = this.clone();
            clone._includer = includer;
            clone._filterer = filterer;
            clone._attributor = attributor;
            clone._paginator = paginator;
            clone._orderer = orderer;
            return clone;
        }
        return this;
    };
    Querier.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._model = this._model;
        clone._byId = this._byId;
        clone._count = this.count;
        clone._includer = this._includer;
        clone._filterer = this._filterer;
        clone._attributor = this._attributor;
        clone._paginator = this._paginator;
        clone._orderer = this._orderer;
    };
    Querier.prototype.createInstance = function () {
        return new Querier(null);
    };
    return Querier;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Querier;
